enum eTypesFigures
  {
   eTF_Circle,
   eTF_Square
  };
//+------------------------------------------------------------------+
enum eTypesValues
  {
   eTV_Radius,
   eTV_Side
  };
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
class CFigure
  {
protected:
   eTypesFigures Type;
public:
   void CFigure() {Type = WRONG_VALUE; }
   eTypesFigures GetType() {return(Type);}
   virtual bool SetValue(eTypesValues TypeValue, double Value) {return(false); }
   virtual bool GetValue(eTypesValues TypeValue, double &Value) {return(false); }
  };
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
class CCircle : public CFigure
  {
   double Radius;
public:
   void CCircle() {Type = eTF_Circle; }
   virtual bool SetValue(eTypesValues TypeValue, double Value);
   virtual bool GetValue(eTypesValues TypeValue, double &Value);
  };
//+------------------------------------------------------------------+
bool CCircle::SetValue(eTypesValues TypeValue, double Value)
{
   switch(TypeValue)
     {
      case eTV_Radius:
         Radius = Value;
         return(true);
      default:
         return(false);
     }
}
//+------------------------------------------------------------------+
bool CCircle::GetValue(eTypesValues TypeValue, double &Value)
{
   switch(TypeValue)
     {
      case eTV_Radius:
         Value = Radius;
         return(true);
      default:
         return(false);
     }
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
class CSquare : public CFigure
  {
   double Side;
public:
   void CSquare() {Type = eTF_Square; }
   virtual bool SetValue(eTypesValues TypeValue, double Value);
   virtual bool GetValue(eTypesValues TypeValue, double &Value);
  };
//+------------------------------------------------------------------+
bool CSquare::SetValue(eTypesValues TypeValue, double Value)
{
   switch(TypeValue)
     {
      case eTV_Side:
         Side = Value;
         return(true);
      default:
         return(false);
     }
}
//+------------------------------------------------------------------+
bool CSquare::GetValue(eTypesValues TypeValue, double &Value)
{
   switch(TypeValue)
     {
      case eTV_Side:
         Value = Side;
         return(true);
      default:
         return(false);
     }
}
//+------------------------------------------------------------------+

CFigure* Figures[2];

//+------------------------------------------------------------------+
void OnStart()
  {
   Figures[0] = new CCircle;
   Figures[1] = new CSquare;
   
   Figures[0].SetValue(eTV_Radius, 10);
   Figures[1].SetValue(eTV_Side, 5);
   
   double tmp;
   if (Figures[0].GetValue(eTV_Radius, tmp))
      Print("    0  ", EnumToString(Figures[0].GetType()), ",  : ", tmp);
   if (Figures[1].GetValue(eTV_Side, tmp))
      Print("    1  ", EnumToString(Figures[1].GetType()), ",  : ", tmp);
   
   delete Figures[0];
   delete Figures[1];
  }